\ProvidesPackage{mymathtools}
\usepackage{amsmath}
\usepackage{amsthm}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsopn}
\usepackage{amsthm}
\usepackage{mathtools}
\usepackage{mathrsfs}
%for commutative diagramms
\usepackage{tikz-cd}
%surjective map:
\newcommand{\surarr}{twoheadrightarrow}
\newcommand{\monarr}{rightarrowtail}
\newcommand{\mmonarr}{\rightarrowtail}
\newcommand{\msurarr}{\twoheadrightarrow}
%embedding:
\newcommand{\embarr}{hookrightarrow}
\newcommand{\membarr}{\hookrightarrow}
%mapsto
\newcommand{\mpt}{mapsto}
%%from  foundrep:

%%text and
\newcommand{\tand}{\qquad\text{and}\qquad}
%for field extensions:
\newcommand{\fearr}{\ar[dash]{d}}
%better substack  https://tex.stackexchange.com/questions/198771/align-in-substack
\makeatletter
\newcommand{\subalign}[1]{%
  \vcenter{%
    \Let@ \restore@math@cr \default@tag
    \baselineskip\fontdimen10 \scriptfont\tw@
    \advance\baselineskip\fontdimen12 \scriptfont\tw@
    \lineskip\thr@@\fontdimen8 \scriptfont\thr@@
    \lineskiplimit\lineskip
    \ialign{\hfil$\m@th\scriptstyle##$&$\m@th\scriptstyle{}##$\crcr
      #1\crcr
    }%
  }
}
\makeatother


%%%
%abbreviations:
%abbreviations - text:
\newcommand{\morph}{morphism~}
\newcommand{\homo}{homomorphism~}
\newcommand{\isom}{isomorphism~}
\newcommand{\tfae}{the following are equivalent}
\newcommand{\abb}{map~}
\newcommand{\tker}{kernel~}
\newcommand{\tcker}{cokernel~}
\newcommand{\homc}[1]{\hom_{\cat{#1}}}
%abbreviations - symbols:
\DeclareMathOperator{\im}{Im}
\DeclareMathOperator{\id}{id}
\DeclareMathOperator{\gl}{GL}
\DeclareMathOperator{\og}{O}
\DeclareMathOperator{\eno}{End}
\DeclareMathOperator{\sqm}{M}
\DeclareMathOperator{\mat}{M}
\DeclareMathOperator{\aut}{Aut}
\DeclareMathOperator{\gal}{Gal}
\DeclareMathOperator{\sgn}{sgn}
\DeclareMathOperator{\coker}{coker}
\DeclareMathOperator{\coim}{coim}
\DeclareMathOperator{\rchar}{char}
\DeclareMathOperator{\syl}{Syl}
\newcommand{\sylp}{\syl_p}
\newcommand{\cat}[1]{\mathcal{#1}}
\newcommand{\objcat}{\text{Ob}}
\newcommand{\objc}[1]{\objcat\left(\cat{#1}\right)}
\newcommand{\pphi}{\varphi}
\newcommand{\glr}[1]{\gl_{#1}(\mathbb{R})}
\newcommand{\orr}[1]{\og_{#1}(\mathbb{R})}
\newcommand{\mnr}[1]{\sqm_{#1}(\mathbb{R})}
\newcommand{\eepsilon}{\varepsilon}

%norms and stuff

\newcommand{\eukno}[1]{\left|\left|#1\right|\right|}
\newcommand{\ip}[2]{\langle #1,#2\rangle}
\DeclareMathOperator{\lin}{Lin}
%\DeclareMathOperator{\sgn}{sgn}
%blackboard symbols
\newcommand{\nn}{\mathbb{N}}
\newcommand{\nne}{\mathbb{N}_1}
\newcommand{\rr}{\mathbb{R}}
\newcommand{\cc}{\mathbb{C}}
\newcommand{\qq}{\mathbb{Q}}
\newcommand{\zz}{\mathbb{Z}}
\newcommand{\ff}{\mathbb{F}}
\newcommand{\fp}{\ff_p}
\newcommand{\pp}{\mathbb{P}}
\newcommand{\kk}{\overline{K}}
\newcommand{\genstr}[1]{\langle #1\rangle}
%set stuff
\newcommand{\ssp}{~|~}
\newcommand{\lset}{\left\lbrace}
\newcommand{\rset}{\right\rbrace}

\newcommand{\sse}{\subseteq}
\newcommand{\ssne}{\subsetneq}
%%
%%einfalgstuff
\newcommand{\divd}{\mid}
\newcommand{\ndivd}{\nmid}
\DeclareMathOperator{\ord}{ord}
\DeclareMathOperator{\abel}{Ab}
\DeclareMathOperator{\abe}{^{\abel}}
\newcommand{\rstk}[1]{\overline{#1}}
\newcommand{\nzz}{\zz/n\zz}
\newcommand{\zzq}[1]{\zz/#1 \zz}
\newcommand{\unts}[1]{{#1}^{\times}}
\newcommand{\grpac}[2]{#1\times #2 \to #2}
\newcommand{\nsg}{\trianglelefteq}
\DeclareMathOperator{\quot}{Quot}
\newcommand{\fkcat}{\backslash \cat{K}}
\newcommand{\fsep}{_{\text{sep}}}
\DeclareMathOperator{\restrop}{restr}
\newcommand{\sdtprod}{\rtimes_{\theta}}
\newcommand{\gaut}{\aut_{\grpc}}
\newcommand{\zeron}{\mathbb{E}_n}
\newcommand{\zeronk}{\zeron(K)}

\newcommand\restr[2]{{% we make the whole thing an ordinary symbol
  \left.\kern-\nulldelimiterspace % automatically resize the bar with \right
  #1 % the function
  \vphantom{\big|} % pretend it's a little taller at normal size
  \right|_{#2} % this is the delimiter
  }}
%categorystuf

\newcommand{\cmod}{\mathsf{Mod}}
\newcommand{\cab}{\cat{A}b}
\newcommand{\op}[1]{#1^{\mathrm{op}}}
\newcommand{\fcr}[1]{\mathsf{#1}}
\newcommand{\nattraf}{\leadsto}
\newcommand{\stc}{\cat{S}et}
\newcommand{\grpc}{\cat{G}rp}
\newcommand{\mdc}{\cat{M}od}
\newcommand{\tpc}{\cat{T}op}
\newcommand{\alc}{\cat{A}lg}
\newcommand{\repc}{\cat{R}ep}
\newcommand{\fnc}{\cat{F}un}
\newcommand{\calc}{\cat{C}omm-\alc}
\DeclareMathOperator{\uptri}{T}
\DeclareMathOperator{\lowtri}{L}
\DeclareMathOperator{\ev}{ev}
\newcommand{\mdas}{\mathrm{-}}
\newcommand{\ccat}{\cat{C}}
\newcommand{\dcat}{\cat{D}}
\newcommand{\ecat}{\cat{E}}
\newcommand{\qcat}{\cat{Q}}

\newcommand{\ffunc}{\fcr{F}}
\newcommand{\gfunc}{\fcr{G}}
\newcommand{\hfunc}{\fcr{H}}
\newcommand{\vfunc}{\fcr{V}}
\newcommand{\ifunc}{\fcr{I}}
\newcommand{\idfunc}{\text{Id}}
\newcommand{\bast}{_{\ast}}
\newcommand{\qct}{\qcat\bast}
\newcommand{\tast}{^{\ast}}
\newcommand{\oobj}{\text{on objects}}
\newcommand{\omor}{\text{on morphism}}
\newcommand{\far}[1]{\overset{#1}{\to}}
\newcommand{\inar}{cramped, sep=small}
%module stuff
\DeclareMathOperator{\rad}{rad}

%algebra stuff
\newcommand{\prf}[2]{$#1$-#2}
\newcommand{\psyl}{$p$-Sylow}
\DeclarePairedDelimiter{\gby}{\langle}{\rangle}
\newcommand{\gseries}[1]{1 = {#1}_0\nsg {#1}_1\nsg \hdots \nsg {#1}_n = #1}
\newcommand{\gseriesb}[1]{1 = \left(#1\right)_0\nsg \left(#1\right)_1\nsg \hdots \nsg \left(#1\right)_n = #1}
\newcommand{\gchainf}[1]{{#1}_i/{#1}_{i-1}}
\newcommand{\gchain}[1]{1 = {#1}_0\leq {#1}_1\leq \hdots \leq {#1}_n = #1}
\newcommand{\gchainb}[1]{1 = \left(#1\right)_0\leq \left(#1\right)_1\leq \hdots \leq \left(#1\right)_n = #1}
\DeclareMathOperator{\spec}{Spec}
\DeclareMathOperator{\maxspec}{MaxSpec}
%field extension stuff
\newcommand{\mip}[2]{\mu_{#1,#2}}

%for tikzcd:

%for num-symb:
\newcommand{\itstp}[1]{^{(#1)}}

\DeclarePairedDelimiter\abs{\lvert}{\rvert}%
\DeclarePairedDelimiter\norm{\lVert}{\rVert}%

\DeclarePairedDelimiter\gen{\langle}{\rangle}

% Swap the definition of \abs* and \norm*, so that \abs
% and \norm resizes the size of the brackets, and the
% starred version does not.
\makeatletter
\let\oldabs\abs
\def\abs{\@ifstar{\oldabs}{\oldabs*}}
%
\let\oldnorm\norm
\def\norm{\@ifstar{\oldnorm}{\oldnorm*}}
\makeatother
%modular stuff
\newcommand{\modu}[1]{~\mathrm{mod}~p}
